﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using WinForms = System.Windows.Forms;

namespace WpfApplication1
{
    /// <summary>
    /// Window1.xaml の相互作用ロジック
    /// </summary>
    public partial class Window1 : Window
    {
        System.Windows.Forms.WebBrowser _browser;
        ObservableCollection<Border> _thumbnails;        

        public Window1()
        {
            InitializeComponent();
            
            _thumbnails = new ObservableCollection<Border>();
            _listbox.ItemsSource = _thumbnails;
            
            _browser = new System.Windows.Forms.WebBrowser();
            wfHost.Child = _browser;

            //_browser.Navigated += new NavigatedEventHandler(_browser_Navigated);
            _browser.Navigated += new System.Windows.Forms.WebBrowserNavigatedEventHandler(_browser_Navigated);
            _browser.Navigate(_textbox.Text);
        }

        private void TextBox_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            switch (e.Key)
            { 
                case Key.Return:
                    try
                    {   
                        if(null == _browser.Url || ( _browser.Url.ToString() != ((sender as TextBox).Text)))
                            _browser.Url = new Uri((sender as TextBox).Text);
                    }
                    catch (Exception)
                    {
                        return;
                    }
                    break;
                default:
                    return;
            }
            e.Handled = true;
        }
        
        void addThumbnail()
        {
            //see http://blogs.msdn.com/jaimer/archive/2007/03/07/using-visualtreehelper-getdrawing-to-get-around-the-z-order-limitation-when-hosting-windows-forms-controls.aspx

            /*
             * in a delegate, web browser drawing is get as a thumbnail image.
             * the delegate must be called throw dispatcher with a low priority (maybe, less than DispatcherPriority.Render), otherwise while box (empty image) is drawn.
             */
            this.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.Background,
                           new System.Windows.Threading.DispatcherOperationCallback(delegate
                           {
                               DrawingGroup dg = VisualTreeHelper.GetDrawing(wfHost);

                               DrawingBrush db = new DrawingBrush(dg);
                               db.TileMode = TileMode.None;
                               db.Stretch = Stretch.Uniform;
                               Rectangle rect = new Rectangle();
                               rect.Width  = wfHost.ActualWidth;
                               rect.Height = wfHost.ActualHeight;
                               rect.Fill = db;
                               Border brd = new Border();
                               brd.Child = rect;
                               _thumbnails.Add(brd);


                               return null;

                           }), null);          
           
        }

        void _browser_Navigated(object sender, System.Windows.Forms.WebBrowserNavigatedEventArgs e)
        {
            string uri = _browser.Url.ToString();
            if (_textbox.Text != uri)
                _textbox.Text = uri;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            addThumbnail();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            _thumbnails.Clear();
        }      
    }
}
